/*
	Snake, Console Game

	move the snake with w, a, s, d
	terminate with x
	
	Linux-System required!
 
	@author: www.c-howto.de
    Enhanced to a real snake game by: peter.sieg2@gmx.de 03/2019
*/

/*
#include <stdbool.h>
#include <stdio.h>
#include <string.h>
#include <termio.h>
#include <unistd.h>
*/
#include <conio.h>

#define BLANK 0
#define HEAD 1
#define TAIL 2
#define FOOD 9
#define WALL '+'
#define KEY_MOVE_UP 'w'
#define KEY_MOVE_LEFT 'a'
#define KEY_MOVE_DOWN 's'
#define KEY_MOVE_RIGHT 'd'
#define KEY_EXIT 'x'
#define WIDTH 26
#define HEIGHT 15
#define DEBUG 0

struct position {
	int x;
	int y;
} pos;

int field[WIDTH][HEIGHT];

void resetField();
void printField();
int getItem(int, int);
void setItem(int, int, int);
int move(int);

int main () {
	int key = KEY_MOVE_UP, lastkey = KEY_MOVE_UP, score = 0;
	resetField();

	pos.x=WIDTH/2;
	pos.y=HEIGHT/2;
	setItem(pos.x, pos.y, HEAD);

	while(key != KEY_EXIT) {
		printField();
 		//key = console_getkey();
 		if (kbhit() != 0) {
 			key = getch();
       		if ((key == KEY_MOVE_UP) || (key == KEY_MOVE_LEFT) || (key == KEY_MOVE_DOWN) || (key == KEY_MOVE_RIGHT)){
            	lastkey = key;
        	}
        }
        else key = lastkey;        


        //usleep(200000);

		if (key != KEY_EXIT) {
            key = move(key);
            score++;
        }
		if(DEBUG) {
			printf("key: %d\n", key);
		}
	}

	printf("\n\nScore: %d\n",score);
	return 0;
}

int move(int key) {

	setItem(pos.x, pos.y, TAIL);
	switch(key) {
		case KEY_MOVE_UP:    pos.y--; break;
		case KEY_MOVE_LEFT:  pos.x--; break;
		case KEY_MOVE_DOWN:  pos.y++; break;
		case KEY_MOVE_RIGHT: pos.x++; break;
	}

//	if(pos.y >= HEIGHT) pos.y=0;
//	if(pos.y < 0) pos.y=HEIGHT-1;
//	if(pos.x >= WIDTH) pos.x=0;
//	if(pos.x < 0) pos.x=WIDTH-1;

    if (getItem(pos.x, pos.y) == BLANK)	{
        setItem(pos.x, pos.y, HEAD);
        return 0;
    }
    else return KEY_EXIT; // snake has moved to none blank field - game over
}

int getItem(int x, int y) {
	return field[x][y];
}

void setItem(int x, int y, int item) {
	field[x][y] = item;
}

void resetField() {
	int x,y;
	for(y=0;y<HEIGHT;y++) {
		for(x=0;x<WIDTH;x++) {
			field[x][y] = WALL;
		}
	}
	for(y=1;y<HEIGHT-1;y++) {
		for(x=1;x<WIDTH-1;x++) {
			field[x][y] = BLANK;
		}
	}
}

void printField() {
	int i,y,x;

	//clear screen
	//fprintf(stdout, "\033[2J");
	//fprintf(stdout, "\033[1;1H");
	clrscr();
	//gotoxy(1,1);

	for(y=0;y<HEIGHT;y++) {
		//printf("\n");
		for(x=0;x<WIDTH;x++) {
			i = field[x][y];
			switch(i) {
			case BLANK: printf(" "); break;
			case TAIL:  printf("*"); break;
			case HEAD:  printf("O"); break;
			case WALL:  printf("+"); break;
			}
		}
	}

	// print debug things
	if(DEBUG) {
		printf("\n\nX: %3d   Y: %3d", pos.x, pos.y);
		printf("\n\nx: %3d   y: %3d", x, y);
	}
}


